global_settings { assumed_gamma 1.3 //1.8
                  radiosity { count 200 
                              nearest_count 6 
                              gray_threshold 0.4
                              distance_maximum 5
                              error_bound 0.38 }
                }  

#default { finish { ambient 0.03 } }
//#default { finish { ambient 1 } }

#declare lRandSeed = seed(546464);

#include "colors.inc"

#include "FernWing.inc"

sky_sphere {
    pigment {
      gradient y
      color_map {
        [ 0.5  rgb <0,0.7,1> ]
        [ 1.0  rgb <0,0,0.8> ]
      }
      scale 2
      translate -1
    }
  }

//plane { y,0 pigment { rgb <0.5,0.2,0> } finish { ambient 0 diffuse 1 } }

#declare Fern_Hanging=1;

#ifdef (Wing)
//        #local lOutFileName = "e:\Wing.inc"
//        #local lOutFileName = "C:\Users\Scharfyj\PovWin\Scenes\Fern\Wing.inc"

        #declare lTriangleCnt = 0;
        light_source { <0,100,-300> color rgb <1,1,0.8> area_light <500,0,0>,<300,0,100>,5,5 jitter adaptive 1 }
        
        #declare lWingLOD = 0;
        #declare lLeafLOD = 0;
        
        MakeLeafTextures()      
        MakeWingTextures()      
//        #include concat(lOutFileName,"_textures")

        camera { location <3,-25,-20> //-65>
                 look_at <3,-25,0>
        }
/*        
        #ifdef(lOutFileName) 
                #fopen lOutFile lOutFileName write 
                #fopen lTextureFile concat(lOutFileName,"_textures") write 
        #end
*/        
        object { 

        FernWing(0,1,1, 0 ,0,0, 5,0.2) 
//        #include lOutFileName
        rotate y*170}
/*
        #ifdef(lOutFileName) 
                #fclose lOutFile 
                #fclose lTextureFile 
        #end
*/
        FernStatistics()
#end

         
#ifdef (Leaf)
        #declare lLeafLOD = 0;
        MakeLeafTextures()
        
        light_source { <-20,5,-200> color rgb <1,1,1> }
        mesh {

        #local lX = 0;
        #while (lX <= 1)
                #if (lX <= 0.5)
                        FernSubLeaf(lX*0.8+0.2,1,0,lX*0.76,0 ,<0,0,0>,<0,0,0>,<0,0,0>,<2*lX*14-7,0,0>) 
                #else
                        FernSubLeaf(lX*0.8+0.2,1,0,lX*0.76,0 ,<0,0,0>,<0,0,0>,<0,0,0>,<2*(lX-0.5)*14-7,-5,0>) 
                #end
               #local lX = lX +0.1;
        #end

//               FernSubLeaf(1,0,0,0.5,0 ,<30,-60,0>,<-80,0,0>,<0,0,0>) 
//               FernSubLeaf(1,0,0,0.5,0 ,<30,-60,0>,<-30,0,0>,<0,0,3>) 

        }
        camera { location <0,0,-20>
                look_at <0,0,0>}
         
        FernStatistics()
#end

#ifdef (Fern_Standing)
        #local lOutFileName = "Fern_Standing.inc"
        #local lTextureFileName = concat(lOutFileName,"_textures")
        
        light_source { <1000,1000,-300> color rgb <1,1,0.8> area_light <200,0,100>,<0,200,200>,5,5 jitter adaptive 1 }
        
        #declare lWingLOD = 0;
        #declare lLeafLOD = 0;

        #declare lFernLODScale = 1;
        #local lLODCenter = <0,20,-40>;
        
        camera { location <0,40,-60>
                 look_at <0,0,0> }
        MakeWingTextures()
        MakeLeafTextures()
                     
//        #include lOutFileName

        plane { y,0 pigment { bozo color_map { [0 rgb <1,1,1>] [1 rgb <1,0.8,0.6>] } scale 20}
                finish { diffuse 1 brilliance 5 } }

        #local lTrans = <0,0,0>;
        
        #ifdef(lOutFileName) 
                #fopen lOutFile lOutFileName write 
                #fopen lTextureFile lTextureFileName write 
        #end
       
        // base
        #local lAngOfs = 0;
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-20+40*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(1, 0.8+0.2*rand(lRandSeed), 0.7, 
                                  0.1*rand(lRandSeed), 0.1*rand(lRandSeed), 0.3+0.5*rand(lRandSeed),
                                  5,0.2)
                         rotate lRot }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/7;
        #end

        // lower median
        #local lAngOfs = 20*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(1, 0.75+0.2*rand(lRandSeed), 0.7, 
                                  0.05*rand(lRandSeed), 0.02*rand(lRandSeed), 0.3*rand(lRandSeed),
                                  3,0.2)
                         rotate lRot }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/6;
        #end

        // upper median
        #local lAngOfs = 40*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(1, 0.6+0.1*rand(lRandSeed), 0.9, 
                                  0.01*rand(lRandSeed), 0, 0.2*rand(lRandSeed),
                                  2,0.2)
                         rotate lRot }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/4;
        #end

        // tip
        #local lAngOfs = 45*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(1, 0.3+0.3*rand(lRandSeed), 1, 
                                  0, 0, 0.1*rand(lRandSeed),
                                  1,0.3)
                         rotate lRot }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/2;
        #end


        // dead leaves

        #declare lLeafLOD = 0;
//        MakeLeafTextures()        

        mesh {
        #ifdef(lOutFile) #write (lOutFile,"mesh{") #end

        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lX = -30+60*rand(lRandSeed);
                #local lZ = -15-20*rand(lRandSeed);
                FernSubLeaf(1,1,1,1,0.1,<0,0,0>,<0,90,0>,<0,0,120>,<lX,1.5,lZ>)
                #local lCnt = lCnt +1/3;
        #end

        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lX = -20+40*rand(lRandSeed);
                #local lZ = -15-40*rand(lRandSeed);
                FernSubLeaf(1,1,1,1,0.1,<0,0,0>,<12,0,90>,<0,360*rand(lRandSeed),0>,<lX,0.8,lZ>)
                #local lCnt = lCnt +1/4;
        #end
        }
        
        #ifdef(lOutFile) #write (lOutFile,"}") #end

        #ifdef(lOutFile)
                #fclose lOutFile 
                #fclose lTextureFile 
        #end
        FernStatistics()
#end

#ifdef (Fern_Hanging)
//        #local lOutFileName = "fern_hanging.inc"
//        #local lOutFileName = "E:\fern_hanging.inc"
        #local lTextureFileName = concat(lOutFileName,"_textures")
        
        light_source { <1000,1000,-300> color rgb <1,1,0.8> area_light <200,0,100>,<0,200,200>,5,5 jitter adaptive 1 }
        
        #declare lWingLOD = 0;
        #declare lLeafLOD = 0;

        #declare lFernLODScale = 1;
        #local lLODCenter = <0,66,-60>;
        
        camera { location <0,120,0>
                 look_at <0,0,0> //<0,45,0>
/*                 aperture 5
                 blur_samples  200
                 focal_point <0,50,-10>
                 confidence 0.9
                 variance 1/100*/
        }
        MakeWingTextures()
        MakeLeafTextures()
        
        #local lTrans = <0,50,0>;
        
        difference {        
                cylinder { <0,0,0>,lTrans,5 }
                #local lCnt = 0;
                #while (lCnt <1)
                        cylinder { <0,-0.1,0>,lTrans,1 scale <1,1.1,0.5>
                                translate z*5
                                rotate y*lCnt*360
                                pigment { rgb <0.5,0.5,0.5> }
                                finish { ambient 0 diffuse 1 brilliance 5 } }
                        
                        #local lCnt = lCnt + 1/10;
                #end
            pigment { rgb <1,1,1> }
            finish { diffuse 0.7 reflection 0.3 phong 1 phong_size 50} 
        }
        plane { y,0 pigment { bozo color_map { [0 rgb <1,1,1>] [1 rgb <1,0.8,0.6>] } scale 20}
                finish { diffuse 1 brilliance 2 } }

/*
        #include lTextureFileName
        #include lOutFileName
*/                

        #ifdef(lOutFileName) 
                #fopen lOutFile lOutFileName write 
                #fopen lTextureFile lTextureFileName write 
        #end
       
        // base
        #local lAngOfs = 0;
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-20+40*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(0, 0.7+0.2*rand(lRandSeed), 0.6, 
                                  0.1*rand(lRandSeed), 0.1*rand(lRandSeed), 0.5+0.2*rand(lRandSeed),
                                  5,0.2)
                         rotate lRot translate lTrans }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/7;
        #end

        // lower median
        #local lAngOfs = 20*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(0, 0.6+0.2*rand(lRandSeed), 0.8, 
                                  0.05*rand(lRandSeed), 0.02*rand(lRandSeed), 0.3*rand(lRandSeed),
                                  3,0.2)
                         rotate lRot translate lTrans } 
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/6;
        #end

        // upper median
        #local lAngOfs = 40*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(0, 0.4+0.2*rand(lRandSeed), 0.9, 
                                  0.01*rand(lRandSeed), 0, 0.2*rand(lRandSeed),
                                  2,0.2)
                         rotate lRot translate lTrans }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/12;
        #end

        // tip
        #local lAngOfs = 45*rand(lRandSeed);        
        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lRot = <0,360*lCnt+(-10+20*rand(lRandSeed))+lAngOfs,0>;
                #declare lFernLODCenter = vrotate(vrotate(vrotate(lLODCenter-lTrans,-z*lRot.z),-y*lRot.y),-x*lRot.x);
                #ifdef(lOutFile) #write (lOutFile,"object{") #end
                object { FernWing(0, 0.3+0.3*rand(lRandSeed), 1, 
                                  0, 0, 0.1*rand(lRandSeed),
                                  1,0.3)
                         rotate lRot translate lTrans }
                #ifdef(lOutFile) #write (lOutFile," rotate ",lRot," translate ",lTrans,"}\n") #end
                #local lCnt = lCnt +1/4;
        #end

        // dead leaves

        #declare lLeafLOD = 0;

        mesh {
        #ifdef(lOutFile) #write (lOutFile,"mesh{") #end

        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lX = -30+60*rand(lRandSeed);
                #local lZ = -5-10*rand(lRandSeed);
                FernSubLeaf(1,1,1,0.8+0.2*rand(lRandSeed),0.1,<0,0,0>,<0,90,0>,<0,0,120>,<lX,1.5,lZ>)
                #local lCnt = lCnt +1/2;
        #end

        #local lCnt = 0;
        #while (lCnt <= 1)
                #local lX = -50+100*rand(lRandSeed);
                #local lZ = 5+40*rand(lRandSeed);
                FernSubLeaf(1,1,1,0.8+0.2*rand(lRandSeed),0.1,<0,0,0>,<12,0,90>,<0,360*rand(lRandSeed),0>,<lX,0.8,lZ>)
                #local lCnt = lCnt +1/6;
        #end
        }

        #ifdef(lOutFile) #write (lOutFile,"}") #end

        #ifdef(lOutFile)
                #fclose lOutFile 
                #fclose lTextureFile 
        #end
        
        FernStatistics()
#end